// rejpeg.cpp		copyright 1998,2004 Hiroyuki Tsutsumi
//  ver.0.01  (Baseline only)

#include	"rejpeg.h"

bool	about=FALSE;

main()
{
	rejpeg*	app;
	app=new rejpeg();
	app->Run();
	delete app;
	return true;
}
//------------------------------------------------
rejpeg::rejpeg():BApplication("application/x-vnd.Beer-rejpeg")
{
	BRect	frame;
	frame.Set(100,100,500,200);
	w=new rejpegwindow(frame);
}

void rejpeg::RefsReceived(BMessage *mes)
{
	uint32	type;
	int32	files;
	mes->GetInfo("refs",&type,&files);
	if(files>0){
		entry_ref	eref;
		BMessage msg(B_SIMPLE_DATA);
		for(int i=0;i<files;i++){
			mes->FindRef("refs",i,&eref);
			msg.AddRef("refs",&eref);
		}
		msg.PrintToStream();
		w->PostMessage(&msg,w->v);
	}
}

void rejpeg::AboutRequested()
{
	if(!about){
		about=TRUE;
		aboutwindow* window=new aboutwindow(BRect(5,25,205,175));
	}
}
//------------------------------------------------
rejpegwindow::rejpegwindow(BRect frame):BWindow(frame,"rejpeg ver.0.01",B_TITLED_WINDOW,0)
{
	BRect	viewframe;
	viewframe.Set(0,0,500,500);
	viewframe.OffsetTo(0,0);
	v=new rejpegview(viewframe);
	AddChild(v);
	Show();
	SetZoomLimits(400,100);
	SetPulseRate(1000000);
}

bool rejpegwindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}
//------------------------------------------------
rejpegview::rejpegview(BRect frame):BView(frame,"rejpegview",B_FOLLOW_ALL_SIDES,B_WILL_DRAW|B_PULSE_NEEDED)
{
	files=0;step=0;wait=0;
	buf=new uchar[bufsize=0x100000];	//1MB
	eref=new entry_ref[maxfiles=100];	//max 100files
}

void rejpegview::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(255,255,240);
	SetLowColor(255,255,240);
	SetFont(be_plain_font);
	SetFontSize(18);
}

void rejpegview::Draw(BRect rect)
{
	if(step<1){
		if(files==0){
			if(step==0){strcpy(mes[0],"Rejpeg  ver.0.01");*(mes[1])=0;}
			SetHighColor(0,50,100);DrawString("Please drop jpeg file.",BPoint(20,90));
		}else{
			SetHighColor(0,50,100);DrawString("Click to next.",BPoint(20,90));
		}
	}
	SetHighColor(0,0,0);DrawString(mes[0],BPoint(20,20));
	SetHighColor(255,100,100);DrawString(mes[1],BPoint(20,55));
}

void rejpegview::Pulse()
{
	if(wait>0)if(--wait==0){step=0;Invalidate();}
}

void rejpegview::MouseDown(BPoint pt)
{
	if((step==0)&&(pt.x<150)&&(pt.y<20))be_app->PostMessage(B_ABOUT_REQUESTED);
	else if((files>0)&&(step<1))main();
}

void rejpegview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case B_SIMPLE_DATA:{
			if(files>0){beep();break;}
			uint32		type;
			msg->GetInfo("refs",&type,&files);
			if(files>maxfiles)files=maxfiles;
			for(int i=0;i<files;i++)msg->FindRef("refs",i,&(eref[i]));
			if(files>0)main();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void rejpegview::main()
{
	wait=0;
	if((step<1)&&(files>0)){
		step=1;
		strcpy(mes[0],eref[files-1].name);
		strcpy(mes[1],"now reading");Invalidate();
		if(readfile(&(eref[files-1]))){
			sprintf(mes[1],"cannot open \"%s\".",eref[files-1].name);Invalidate();
			gonext();return;
		}
	}
	if(step==1){
		step=2;
		strcpy(mes[1],"now re-coding");Invalidate();
		if(re_jpeg()){
			strcpy(mes[1],"not support this type.");Invalidate();
			gonext();return; 
		}
	}
	if(step==2){
		step=3;
		strcpy(mes[1],"now writing");Invalidate();
		if(writefile(&(eref[files-1]))){
			strcpy(mes[1],"cannot open file for write.");Invalidate();
			gonext();return;
		}
	}
	if(step==3){
		sprintf(mes[1],"success rejpeg \"%s\".",eref[files-1].name);Invalidate();
		gonext();return;
	}
}

void rejpegview::gonext()
{
	step=-1;
	if(--files==0)wait=5;
	Invalidate();
}

int rejpegview::re_jpeg()
{
	rp=rbuf;rpb=0x80;
	markf=0;
	while(readmarker()>0);
	if(markf!=0xcf)return(1);
	for(int t=0;t<4;t++)for(int i=0;i<256;i++)count[t][i]=0;
	for(int oy=0;oy<height;oy+=16)for(int ox=0;ox<width;ox+=16){
		for(int k=0;k<6;k++){
			if(k<4)de_huff(0,1);else de_huff(2,3);		//Y,UV
		}
	}
	if(readmarker()!=M_EOI)return(2);
	for(int t=0;t<4;t++)create_dht(t);
	rp=rbuf;rpb=0x80;
	wp=wbuf;wpb=0x80;
	writeheader();
	for(int oy=0;oy<height;oy+=16)for(int ox=0;ox<width;ox+=16){
		for(int k=0;k<6;k++){
			if(k<4)en_huff(0,1);else en_huff(2,3);		//Y,UV
		}
	}
	while(wpb!=0x80)writebits(0x10000);
	WRITE1BYTE(0xff);WRITE1BYTE(M_EOI);
	return(0);
}

uchar rejpegview::readmarker()
{
	uchar	m;
	int		len;
	uchar	dum;
	if(rpb!=0x80){rp++;rpb=0x80;}
	if(READ1BYTE!=0xff){rp--;return(0);}
	m=READ1BYTE;
	if((m!=M_SOI)&&(m!=M_EOI))len=READ2BYTE;
	switch(m){
		case M_SOI:{
			markf=0x80;
		}break;
		case M_EOI:break;
		case M_SOF0:{
			rp++;
			height=READ2BYTE;
			width=READ2BYTE;
			dum=READ1BYTE;
			rp+=dum*3;
			markf|=0x40;
		}break;
		case M_DHT:{
			int	no,c,l,b[16],n1,n2,n3;
			dum=READ1BYTE;
			no=((dum&0x10)>>4)|((dum&0x01)<<1);
			c=0;for(l=0;l<16;l++)c+=(b[l]=READ1BYTE);
			n1=0;n2=2;
			for(l=0;c>0;l++){
				n3=n2;while(n1<n3){huff_tbl[no][n1++]=n2;n2+=2;}
				for(int i=0;i<b[l];i++){
					huff_tbl[no][n1++]=0;
					huff_tbl[no][n1++]=READ1BYTE;
					c--;
				}
			}
			markf|=1<<no;
		}break;
		default:{
			rp+=len-2;
		}
	}
	return(m);
}

void rejpegview::de_huff(int t1,int t2)
{
	uint16	n,h;
	n=0;
	while(h=huff_tbl[t1][n])n=readbit()?huff_tbl[t1][n+1]:h;
	readbits(n=huff_tbl[t1][n+1]);
	count[t1][n]++;
	for(int i=1;i<64;){
		n=0;
		while(h=huff_tbl[t2][n])n=readbit()?huff_tbl[t2][n+1]:h;
		n=huff_tbl[t2][n+1];
		count[t2][n]++;
		if(n==0){
			break;
		}else{
			i+=(n>>4)+1;
			readbits(n&0x0f);
		}
	}
}

void rejpegview::create_dht(int t)
{
	int		br[18],lf[18];
	int		c,p,pp,b,bb,mb;
	uint32	cc,mc,d;
	for(c=0;c<256;c++){
		pp=c;
		if(count[t][c]>0){
			while(pp-->0)if(count[t][c]<=count[t][sort[t][pp]])break;
			pp++;
			for(int j=c;j>pp;j--)sort[t][j]=sort[t][j-1];
		}
		sort[t][pp]=c;
	}
	for(int i=0;i<18;i++)br[i]=lf[i]=0;
	for(c=0;c<256;c++){
		cc=count[t][sort[t][c]];
		if(cc<=0)break;
		if(c==0){lf[0]=1;continue;}
		p=0;mc=0;
		for(b=0;b<16;b++){
			if(br[b]<(1<<b)){
				bb=b;
				pp=p+lf[bb++];
				d=count[t][sort[t][pp-1]];
				while((pp+=lf[bb])<c){d-=count[t][sort[t][pp]];bb++;}
				d+=cc*bb;
				if((mc==0)||(mc>d)){mc=d;mb=b;}
			}
			if(br[b]==0)break;
			p+=lf[b];
		}
		lf[mb]--;br[mb]++;lf[mb+1]++;
		lf[mb+1]++;
	}
	for(int i=0;i<16;i++)en_huffbits_tbl[t][i]=lf[i+1];
}

void rejpegview::writeheader()
{
	uchar	m,d,*pp;
	uint16	len;
	while(1){
		pp=rp;
		if(READ1BYTE!=0xff){rp--;break;}
		m=READ1BYTE;
		if((m!=M_SOI)&&(m!=M_EOI)){
			len=READ2BYTE;
			if(m==M_DHT){d=READ1BYTE;len--;}
			rp+=len-2;
		}
		if(m==M_DHT){
			int c,t,b,h;
			c=0;
			t=((d&0x10)>>4)|((d&0x01)<<1);
			for(int i=0;i<16;i++)c+=en_huffbits_tbl[t][i];
			WRITE1BYTE(0xff);
			WRITE1BYTE(m);
			WRITE2BYTE(c+19);
			WRITE1BYTE(d);
			for(int i=0;i<16;i++)WRITE1BYTE(en_huffbits_tbl[t][i]);
			for(int i=0;i<c;i++)WRITE1BYTE(sort[t][i]);
			h=0;
			c=0;
			for(b=0;b<16;b++){
				for(int i=0;i<en_huffbits_tbl[t][b];i++){
					en_huff_tbl[t][sort[t][c++]]=((uint32)(b+1)<<16)|(h++);
				}
				h<<=1;
			}
		}else{
			memcpy(wp,pp,rp-pp);wp+=rp-pp;
		}
	}
}

void rejpegview::en_huff(int t1,int t2)
{
	uint16	n,h;
	n=0;
	while(h=huff_tbl[t1][n])n=readbit()?huff_tbl[t1][n+1]:h;
	n=huff_tbl[t1][n+1];
	writebits(en_huff_tbl[t1][n]);
	copybits(n);
	for(int i=1;i<64;){
		n=0;
		while(h=huff_tbl[t2][n])n=readbit()?huff_tbl[t2][n+1]:h;
		n=huff_tbl[t2][n+1];
		writebits(en_huff_tbl[t2][n]);
		if(n==0){
			break;
		}else{
			i+=(n>>4)+1;
			copybits(n&0x0f);
		}
	}
}

uchar rejpegview::readbit()
{
	uchar r=((*rp)&rpb)?1:0;
	if(rpb==1){
		rpb=0x80;
		if((*rp==0xff)&&(*(rp+1)==0))rp++;
		rp++;
	}else{
		rpb>>=1;
	}
	return(r);
}

int32 rejpegview::readbits(int n)
{
	int32 r=0;
	bool f=(((*rp)&rpb)==0);
	for(int i=0;i<n;i++){
		r<<=1;
		if((*rp)&rpb)r++;
		if(rpb==1){
			rpb=0x80;
			if((*rp==0xff)&&(*(rp+1)==0))rp++;
			rp++;
		}else{
			rpb>>=1;
		}
	}
	if(f)r=r-((1<<n)-1);
	return(r);
}

void rejpegview::writebits(uint32 h)
{
	int n=h>>16;uint d=h&0xffff;
	uint b=1<<(n-1);
	while(n-->0){
		if(wpb==0x80)*wp=0;
		if(d&b)(*wp)|=wpb;
		if(wpb==0x01){
			if(*wp==0xff)*(++wp)=0;
			wpb=0x80;
			wp++;
		}else{
			wpb>>=1;
		}
		b>>=1;
	}
}

void rejpegview::copybits(int n)
{
	while(n-->0){
		if(wpb==0x80)*wp=0;
		if((*rp)&rpb)(*wp)|=wpb;
		if(rpb==0x01){
			if((*rp==0xff)&&(*(rp+1)==0))rp++;
			rpb=0x80;
			rp++;
		}else{
			rpb>>=1;
		}
		if(wpb==0x01){
			if(*wp==0xff)*(++wp)=0;
			wpb=0x80;
			wp++;
		}else{
			wpb>>=1;
		}
	}
}

int rejpegview::readfile(entry_ref *r_eref)
{
	BFile	rf(r_eref,O_RDONLY|O_BINARY);
	struct stat	rfst;
	rf.GetStat(&rfst);
	rsize=rfst.st_size;
	rbuf=buf+bufsize-rsize;
	if(rf.Read(rbuf,rsize)<rsize)return(1);
	wbuf=buf;
	return(0);
}

int rejpegview::writefile(entry_ref *w_eref)
{
	BEntry	r_ent(w_eref);
	char	s[256];
	strcpy(s,w_eref->name);strcat(s,".org");
	if(r_ent.Rename(s))return(2);
	BFile	wf(w_eref,O_WRONLY|O_CREAT);
	wsize=wp-wbuf;
	if(wf.Write(wbuf,wsize)<wsize)return(3);
	return(0);
}
//------------------------------------------------
aboutwindow::aboutwindow(BRect frame):BWindow(frame,"about (rejpeg)",B_TITLED_WINDOW,B_NOT_RESIZABLE)
{
	BRect	aframe;
	aframe.Set(0,0,200,150);		aframe.OffsetTo(0,0);
	aview=new aboutview(aframe);	AddChild(aview);
	Show();
	SetZoomLimits(200,150);
}

bool aboutwindow::QuitRequested()
{
	about=FALSE;
	return true;
}
//------------------------------------------------
aboutview::aboutview(BRect frame):BView(frame,"aboutview",B_NOT_RESIZABLE,B_WILL_DRAW)
{
}

void aboutview::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(222,255,222);
	SetLowColor(222,255,222);
	SetFont(be_plain_font);
}

void aboutview::Draw(BRect rect)
{
	SetFontSize(18);
	DrawString("REJPEG  ver.0.01"					,BPoint(30,30));
	SetFontSize(12);
	DrawString("2004.11. 4"							,BPoint(100,60));
	DrawString("Copyright Hiroyuki Tsutsumi"		,BPoint(30,100));
	DrawString("gch07232@nifty.ne.jp"				,BPoint(15,120));
	DrawString("http://www.eonet.ne.jp/~hirotsu/"	,BPoint(15,140));
}
