// rejpeg.h
//  ver.0.01  (Baseline only)

#include	<Be.h>

class rejpegview:public BView
{
	public:
		rejpegview(BRect frame);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	Pulse();
		void	MouseDown(BPoint pt);
		void	MessageReceived(BMessage *msg);
		void	main();
		void	gonext();
		int		re_jpeg();
		uchar	readmarker();
		void	de_huff(int t1,int t2);		//Decode Huffman (count)
		void	create_dht(int t);			//create best-huffman
		void	writeheader();
		void	en_huff(int t1,int t2);		//Encode Huffman (re-code)
		uchar	readbit();
		int32	readbits(int n);
		void	writebits(uint32 h);
		void	copybits(int n);
		int		readfile(entry_ref *r_eref);
		int		writefile(entry_ref *w_eref);
		int		step;						//0.title 1.read 2.rejpeg 3.write 4.ok,cansel
		char	mes[2][256];
		int		wait;
	private:
		int32		files,maxfiles;
		entry_ref	*eref;
		uchar		*buf,*rbuf,*wbuf;		//buffer
		ssize_t		bufsize,rsize,wsize;
		uchar		*rp,rpb;				//reading_point
		uchar		*wp,wpb;				//writing_point
		uchar		markf;					//marker flag  b7.SOI b6.SOF0 b0-3.DHT
		int			width,height;
		uint16		huff_tbl[4][1024];
		uint32		count[4][256];
		uchar		sort[4][256];
		uchar		en_huffbits_tbl[4][16];
		uint32		en_huff_tbl[4][256];
};

class rejpegwindow:public BWindow
{
	public:
		rejpegwindow(BRect frame);
		bool	QuitRequested();
		rejpegview	*v;
};

class rejpeg:public BApplication
{
	public:
		rejpeg();
		void	RefsReceived(BMessage *mes);
		void	AboutRequested();
		rejpegwindow	*w;
};

class aboutview:public BView
{
	public:
		aboutview(BRect frame);
		void	AttachedToWindow();
		void	Draw(BRect rect);
};

class aboutwindow:public BWindow
{
	public:
		aboutwindow(BRect frame);
		bool	QuitRequested();
	private:
		aboutview	*aview;
};

typedef enum{		// JPEG marker codes
						//coding mode
	M_SOF0	=0xc0,			// Baseline
	M_SOF1	=0xc1,			// Extended sequential, Huffman
	M_SOF2	=0xc2,			// Progressive, Huffman
	M_SOF3	=0xc3,			// Lossless, Huffman
	M_SOF5	=0xc5,			// Differential sequential, Huffman
	M_SOF6	=0xc6,			// Differential progressive, Huffman
	M_SOF7	=0xc7,			// Differential lossless, Huffman
	M_JPG	=0xc8,			// Reserved for JPEG extensions
	M_SOF9	=0xc9,			// Extended sequential, arithmetic
	M_SOF10	=0xca,			// Progressive, arithmetic
	M_SOF11	=0xcb,			// Lossless, arithmetic
	M_SOF13	=0xcd,			// Differential sequential, arithmetic
	M_SOF14	=0xce,			// Differential progressive, arithmetic
	M_SOF15	=0xcf,			// Differential lossless, arithmetic

	M_DHT	=0xc4,		//Huffman-table
	M_DAC	=0xcc,
	M_RST0	=0xd0,
	M_RST1	=0xd1,
	M_RST2	=0xd2,
	M_RST3	=0xd3,
	M_RST4	=0xd4,
	M_RST5	=0xd5,
	M_RST6	=0xd6,
	M_RST7	=0xd7,
	M_SOI	=0xd8,		//top of file
	M_EOI	=0xd9,		//end of file
	M_SOS	=0xda,
	M_DQT	=0xdb,		//Quant-table
	M_DNL	=0xdc,
	M_DRI	=0xdd,
	M_DHP	=0xde,
	M_EXP	=0xdf,
	M_APP0	=0xe0,
	M_APP1	=0xe1,
	M_APP2	=0xe2,
	M_APP3	=0xe3,
	M_APP4	=0xe4,
	M_APP5	=0xe5,
	M_APP6	=0xe6,
	M_APP7	=0xe7,
	M_APP8	=0xe8,
	M_APP9	=0xe9,
	M_APP10	=0xea,
	M_APP11	=0xeb,
	M_APP12	=0xec,
	M_APP13	=0xed,
	M_APP14	=0xee,
	M_APP15	=0xef,
	M_JPG0	=0xf0,
	M_JPG13	=0xfd,
	M_COM	=0xfe,
	M_TEM	=0x01,
};

#define	READ1BYTE		*(rp++)
#define	READ2BYTE		B_BENDIAN_TO_HOST_INT16(*(uint16*)rp),rp+=2
#define	WRITE1BYTE(x)	{*(wp++)=(x);}
#define	WRITE2BYTE(x)	{*(wp++)=(x)>>8;*(wp++)=(x)&0xff;}
